/*
 * This file is part of the Arduino I2C keyboard.
 * Copyright (C) 2018  Forest Godfrey <fgodfrey@bigw.org>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#ifndef _AI2C_H
#define _AI2C_H

typedef struct arduino_i2c_driver_data_s  {
	struct list_head driver_list;
	struct work_struct intr_upper_work;
	struct i2c_client *client;
	struct input_dev *indev;
	int irq_num;
	int irq_pin;
	int irq_count;
	int numkeys;
	int *keymap;
} arduino_i2c_driver_data_t;

#endif /* _AI2C_H */
